Index: branches/new_class_id/src/Makefile.am
===================================================================
--- branches/new_class_id/src/Makefile.am	(revision 9793)
+++ branches/new_class_id/src/Makefile.am	(revision 9794)
@@ -42,5 +42,8 @@
 		util/kill_target.cc \
 		\
-		subprojects/benchmark.cc
+		subprojects/benchmark.cc \
+		\
+		\
+		lib/util/loading/resource_manager.cc
 
 noinst_HEADERS = \
Index: branches/new_class_id/src/lib/BuildLibs.am
===================================================================
--- branches/new_class_id/src/lib/BuildLibs.am	(revision 9793)
+++ branches/new_class_id/src/lib/BuildLibs.am	(revision 9794)
@@ -17,6 +17,4 @@
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
                 \
-                $(LIB_PREFIX)/util/libORXlibutil.a \
-                \
                 $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
                 $(LIB_PREFIX)/graphics/importer/libtc.a \
Index: branches/new_class_id/src/lib/shell/some_shell_commands.cc
===================================================================
--- branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9793)
+++ branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9794)
@@ -52,6 +52,8 @@
 ->completionPlugin(0, CompletorFileSystem());
 
-#include "loading/resource_manager.h"
-SHELL_COMMAND(debug, ResourceManager, debug);
+#include "loading/new_resource_manager.h"
+SHELL_COMMAND(debug, NewResourceManager, debug);
+
+
 #include "loading/load_param_class_description.h"
 SHELL_COMMAND_STATIC(printAll, LoadParamClassDescription, &LoadParamClassDescription::printAll)
@@ -59,2 +61,8 @@
 SHELL_COMMAND_STATIC(capture, LoadParamClassDescription, &LoadParamClassDescription::captureDescriptions)
     ->defaultValues(true);
+
+#include "loading/game_loader.h"
+SHELL_COMMAND(quit, GameLoader, stop)
+    ->describe("quits the game")
+    ->setAlias("orxoquit");
+
Index: branches/new_class_id/src/lib/util/Makefile.am
===================================================================
--- branches/new_class_id/src/lib/util/Makefile.am	(revision 9793)
+++ branches/new_class_id/src/lib/util/Makefile.am	(revision 9794)
@@ -15,5 +15,4 @@
 		multi_type.cc \
 		\
-		loading/resource_manager.cc \
 		loading/new_resource_manager.cc \
 		loading/resource.cc \
Index: branches/new_class_id/src/lib/util/loading/game_loader.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/game_loader.cc	(revision 9793)
+++ branches/new_class_id/src/lib/util/loading/game_loader.cc	(revision 9794)
@@ -22,5 +22,4 @@
 
 #include "debug.h"
-#include "shell_command.h"
 #include "campaign.h"
 
@@ -30,10 +29,4 @@
 
 ObjectListDefinition(GameLoader);
-
-
-SHELL_COMMAND(quit, GameLoader, stop)
-->describe("quits the game")
-->setAlias("orxoquit");
-
 
 GameLoader* GameLoader::singletonRef = NULL;
Index: branches/new_class_id/src/lib/util/loading/new_resource_manager.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/new_resource_manager.cc	(revision 9793)
+++ branches/new_class_id/src/lib/util/loading/new_resource_manager.cc	(revision 9794)
@@ -22,5 +22,5 @@
 #include <assert.h>
 
-//ObjectListDefinition(NewResourceManager);
+ObjectListDefinition(NewResourceManager);
 
 
@@ -34,5 +34,5 @@
 NewResourceManager::NewResourceManager ()
 {
-//  this->registerObject(this, NewResourceManager::_objectList);
+  //this->registerObject(this, NewResourceManager::_objectList);
   this->setName("NewResourceManager");
 
Index: branches/new_class_id/src/lib/util/loading/new_resource_manager.h
===================================================================
--- branches/new_class_id/src/lib/util/loading/new_resource_manager.h	(revision 9793)
+++ branches/new_class_id/src/lib/util/loading/new_resource_manager.h	(revision 9794)
@@ -12,5 +12,5 @@
 class NewResourceManager : public BaseObject
 {
-//  ObjectListDeclaration(NewResourceManager);
+  ObjectListDeclaration(NewResourceManager);
 public:
   virtual ~NewResourceManager();
Index: branches/new_class_id/src/lib/util/loading/resource.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/resource.cc	(revision 9793)
+++ branches/new_class_id/src/lib/util/loading/resource.cc	(revision 9794)
@@ -134,5 +134,5 @@
 {
   NewResourceManager::getInstance()->registerType(this);
-  printf("%s\n", typeName.c_str());
+  PRINTF(4)("Created ResourceType '%s'\n", typeName.c_str());
 }
 