Index: branches/new_class_id/src/lib/graphics/importer/resource_texture.h
===================================================================
--- branches/new_class_id/src/lib/graphics/importer/resource_texture.h	(revision 9799)
+++ branches/new_class_id/src/lib/graphics/importer/resource_texture.h	(revision 9800)
@@ -12,5 +12,5 @@
 
 
-class ResourceTexture : public Texture, public NewResource
+class ResourceTexture : public Texture, public Resources::NewResource
 {
 public:
Index: branches/new_class_id/src/lib/shell/some_shell_commands.cc
===================================================================
--- branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9799)
+++ branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9800)
@@ -53,6 +53,6 @@
 
 #include "loading/new_resource_manager.h"
-SHELL_COMMAND(debug, NewResourceManager, debug);
-
+namespace Resources
+{SHELL_COMMAND(debug, NewResourceManager, debug);}
 
 #include "loading/load_param_class_description.h"
Index: branches/new_class_id/src/lib/util/loading/new_resource_manager.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/new_resource_manager.cc	(revision 9799)
+++ branches/new_class_id/src/lib/util/loading/new_resource_manager.cc	(revision 9800)
@@ -22,156 +22,158 @@
 #include <cassert>
 
-ObjectListDefinition(NewResourceManager);
+
+namespace Resources
+{
+  ObjectListDefinition(NewResourceManager);
+  //! Singleton Reference to the NewResourceManager
+  NewResourceManager* NewResourceManager::_singletonRef = NULL;
 
 
-//! Singleton Reference to the NewResourceManager
-NewResourceManager* NewResourceManager::_singletonRef = NULL;
+  /**
+   * @brief standard constructor
+  */
+  NewResourceManager::NewResourceManager ()
+  {
+    this->registerObject(this, NewResourceManager::_objectList);
+    this->setName("NewResourceManager");
+
+    //this->dataDir = "./";
+  }
 
 
-/**
- * @brief standard constructor
-*/
-NewResourceManager::NewResourceManager ()
-{
-  this->registerObject(this, NewResourceManager::_objectList);
-  this->setName("NewResourceManager");
+  /**
+   * @brief standard destructor
+  */
+  NewResourceManager::~NewResourceManager ()
+  {
+    // deleting the Resources-List
+    //this->unloadAllByPriority(RP_GAME);
 
-  //this->dataDir = "./";
-}
+    //   if (!this->resourceList.empty())
+    //     PRINTF(1)("Not removed all Resources, since there are still %d resources registered\n", this->resourceList.size());
 
-
-/**
- * @brief standard destructor
-*/
-NewResourceManager::~NewResourceManager ()
-{
-  // deleting the Resources-List
-  //this->unloadAllByPriority(RP_GAME);
-
-  //   if (!this->resourceList.empty())
-  //     PRINTF(1)("Not removed all Resources, since there are still %d resources registered\n", this->resourceList.size());
-
-  NewResourceManager::_singletonRef = NULL;
-}
+    NewResourceManager::_singletonRef = NULL;
+  }
 
 
 
 
-void NewResourceManager::registerType(Resources::Type* type)
-{
-  if(type->id() == -1)
+  void NewResourceManager::registerType(Resources::Type* type)
   {
-    type->setID(this->_resourceTypes.size());
-    this->_resourceTypes.push_back(type);
-    PRINTF(5)("ResourceType '%s' with ID %d added\n", type->storedClassName().c_str(), type->id());
+    if(type->id() == -1)
+    {
+      type->setID(this->_resourceTypes.size());
+      this->_resourceTypes.push_back(type);
+      PRINTF(5)("ResourceType '%s' with ID %d added\n", type->storedClassName().c_str(), type->id());
+    }
   }
-}
 
-void NewResourceManager::unregisterType(Resources::Type* type)
-{
-  std::vector<Resources::Type*>::iterator it = std::find (this->_resourceTypes.begin(), this->_resourceTypes.end(), type);
-  if (it != this->_resourceTypes.end())
+  void NewResourceManager::unregisterType(Resources::Type* type)
   {
-    this->_resourceTypes.erase(it);
-    PRINTF(5)("ResourceType '%s' with ID %d removed\n", type->storedClassName().c_str(), type->id());
+    std::vector<Resources::Type*>::iterator it = std::find (this->_resourceTypes.begin(), this->_resourceTypes.end(), type);
+    if (it != this->_resourceTypes.end())
+    {
+      this->_resourceTypes.erase(it);
+      PRINTF(5)("ResourceType '%s' with ID %d removed\n", type->storedClassName().c_str(), type->id());
+    }
   }
-}
 
 
-void NewResourceManager::setMainGlobalPath(const Directory& directory)
-{
-  this->_mainGlobalPath = directory;
-  this->_mainGlobalPath.open();
-}
+  void NewResourceManager::setMainGlobalPath(const Directory& directory)
+  {
+    this->_mainGlobalPath = directory;
+    this->_mainGlobalPath.open();
+  }
 
-void NewResourceManager::addGlobalPath(const Directory& directory)
-{
-  std::vector<Directory>::const_iterator it = std::find(this->_globalPaths.begin(), this->_globalPaths.end(), directory);
-  if (it == this->_globalPaths.end())
-    this->_globalPaths.push_back(directory);
-}
+  void NewResourceManager::addGlobalPath(const Directory& directory)
+  {
+    std::vector<Directory>::const_iterator it = std::find(this->_globalPaths.begin(), this->_globalPaths.end(), directory);
+    if (it == this->_globalPaths.end())
+      this->_globalPaths.push_back(directory);
+  }
 
 
-bool NewResourceManager::addResourcePath(const std::string& resourceName, const std::string& pathName)
-{
-  std::vector<Resources::Type*>::iterator it;
-  for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
-    if (*(*it) == resourceName)
-      return (*it)->addResourcePath(pathName);
-  PRINTF(2)("ResourcePath %s could not be added to the ResourceType %s\n", pathName.c_str(), resourceName.c_str());
-  return false;
-}
+  bool NewResourceManager::addResourcePath(const std::string& resourceName, const std::string& pathName)
+  {
+    std::vector<Resources::Type*>::iterator it;
+    for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
+      if (*(*it) == resourceName)
+        return (*it)->addResourcePath(pathName);
+    PRINTF(2)("ResourcePath %s could not be added to the ResourceType %s\n", pathName.c_str(), resourceName.c_str());
+    return false;
+  }
 
-bool NewResourceManager::addResourceSubPath(const std::string& resourceName, const std::string& pathName)
-{
-  std::vector<Resources::Type*>::iterator it;
-  for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
-    if (*(*it) == resourceName)
-      return (*it)->addResourceSubPath(pathName);
-  PRINTF(2)("ResourceSubPath %s could not be added to the ResourceType %s\n", pathName.c_str(), resourceName.c_str());
-  return false;
-}
+  bool NewResourceManager::addResourceSubPath(const std::string& resourceName, const std::string& pathName)
+  {
+    std::vector<Resources::Type*>::iterator it;
+    for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
+      if (*(*it) == resourceName)
+        return (*it)->addResourceSubPath(pathName);
+    PRINTF(2)("ResourceSubPath %s could not be added to the ResourceType %s\n", pathName.c_str(), resourceName.c_str());
+    return false;
+  }
 
 
 
-bool NewResourceManager::checkFileInMainPath(const File& fileInside)
-{
-  return (this->_mainGlobalPath + fileInside).exists();
-}
+  bool NewResourceManager::checkFileInMainPath(const File& fileInside)
+  {
+    return (this->_mainGlobalPath + fileInside).exists();
+  }
 
 
 
-unsigned int NewResourceManager::addKeepLevelName(const std::string& keepLevelName)
-{
-  this->_keepLevelNames.push_back(keepLevelName);
-  return _keepLevelNames.size()-1;
-}
+  unsigned int NewResourceManager::addKeepLevelName(const std::string& keepLevelName)
+  {
+    this->_keepLevelNames.push_back(keepLevelName);
+    return _keepLevelNames.size()-1;
+  }
 
-unsigned int NewResourceManager::getKeepLevelID(const std::string& keepLevelName) const
-{
-  for (unsigned int i = 0; i < this->_keepLevelNames.size(); ++i)
-    if (this->_keepLevelNames[i] == keepLevelName)
-      return i;
+  unsigned int NewResourceManager::getKeepLevelID(const std::string& keepLevelName) const
+  {
+    for (unsigned int i = 0; i < this->_keepLevelNames.size(); ++i)
+      if (this->_keepLevelNames[i] == keepLevelName)
+        return i;
 
-  PRINTF(2)("KeepLevel '%s' not found. Using 0 instead\n", keepLevelName.c_str());
-  return 0;
-}
+    PRINTF(2)("KeepLevel '%s' not found. Using 0 instead\n", keepLevelName.c_str());
+    return 0;
+  }
 
-const std::string& NewResourceManager::getKeepLevelName(unsigned int keepLevelID) const
-{
-  assert(keepLevelID < this->_keepLevelNames.size());
-  return this->_keepLevelNames[keepLevelID];
-}
+  const std::string& NewResourceManager::getKeepLevelName(unsigned int keepLevelID) const
+  {
+    assert(keepLevelID < this->_keepLevelNames.size());
+    return this->_keepLevelNames[keepLevelID];
+  }
 
 
-/**
- * @brief outputs debug information about the NewResourceManager
- */
-void NewResourceManager::debug() const
-{
-  PRINT(0)("=RM===================================\n");
-  PRINT(0)("= RESOURCE-MANAGER DEBUG INFORMATION =\n");
-  PRINT(0)("======================================\n");
-  PRINT(0)(" MainGlobal search path is %s\n", this->_mainGlobalPath.name().c_str());
-  if(!this->_globalPaths.empty())
+  /**
+   * @brief outputs debug information about the NewResourceManager
+   */
+  void NewResourceManager::debug() const
   {
-    PRINT(0)(" Additional Global search Paths are: ");
-    for (unsigned int i = 0; i < this->_globalPaths.size(); ++i)
-      PRINT(0)("'%s' ", this->_globalPaths[i].name().c_str());
+    PRINT(0)("=RM===================================\n");
+    PRINT(0)("= RESOURCE-MANAGER DEBUG INFORMATION =\n");
+    PRINT(0)("======================================\n");
+    PRINT(0)(" MainGlobal search path is %s\n", this->_mainGlobalPath.name().c_str());
+    if(!this->_globalPaths.empty())
+    {
+      PRINT(0)(" Additional Global search Paths are: ");
+      for (unsigned int i = 0; i < this->_globalPaths.size(); ++i)
+        PRINT(0)("'%s' ", this->_globalPaths[i].name().c_str());
+      PRINT(0)("\n");
+    }
+    PRINT(0)(" Listing %d Types: \n", this->_resourceTypes.size());
+    std::vector<Resources::Type*>::const_iterator it;
+    for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
+    {
+      (*it)->debug();
+      if (it != --this->_resourceTypes.end())
+        PRINT(0)(" ------------------------------------\n ");
+    }
+
+    PRINT(0)("KeepLevels are: ");
+    for (unsigned int i = 0; i < this->_keepLevelNames.size(); ++i)
+      PRINT(0)("%d:'%s'  ", i, this->_keepLevelNames[i].c_str());
     PRINT(0)("\n");
+    PRINT(0)("==================================RM==\n");
   }
-  PRINT(0)(" Listing %d Types: \n", this->_resourceTypes.size());
-  std::vector<Resources::Type*>::const_iterator it;
-  for (it = this->_resourceTypes.begin(); it != this->_resourceTypes.end(); ++it)
-  {
-    (*it)->debug();
-    if (it != --this->_resourceTypes.end())
-      PRINT(0)(" ------------------------------------\n ");
-  }
-
-  PRINT(0)("KeepLevels are: ");
-  for (unsigned int i = 0; i < this->_keepLevelNames.size(); ++i)
-    PRINT(0)("%d:'%s'  ", i, this->_keepLevelNames[i].c_str());
-  PRINT(0)("\n");
-  PRINT(0)("==================================RM==\n");
 }
Index: branches/new_class_id/src/lib/util/loading/new_resource_manager.h
===================================================================
--- branches/new_class_id/src/lib/util/loading/new_resource_manager.h	(revision 9799)
+++ branches/new_class_id/src/lib/util/loading/new_resource_manager.h	(revision 9800)
@@ -10,54 +10,59 @@
 #include "filesys/directory.h"
 
-class NewResourceManager : public BaseObject
+namespace Resources
 {
-  ObjectListDeclaration(NewResourceManager);
-public:
-  /** @returns a Pointer to the only object of this Class */
-  inline static NewResourceManager* getInstance() { if (!_singletonRef) _singletonRef = new NewResourceManager();  return _singletonRef; };
+
+  class NewResourceManager : public BaseObject
+  {
+    ObjectListDeclaration(NewResourceManager);
+  public:
+    /** @returns a Pointer to the only object of this Class */
+    inline static NewResourceManager* getInstance() { if (!_singletonRef) _singletonRef = new NewResourceManager();  return _singletonRef; };
   inline static void deleteInstance() { if (_singletonRef) delete _singletonRef; };
 
 
-  void setMainGlobalPath(const Directory& directory);
-  void addGlobalPath(const Directory& directory);
+    void setMainGlobalPath(const Directory& directory);
+    void addGlobalPath(const Directory& directory);
 
-  bool addResourcePath(const std::string& resourceName, const std::string& pathName);
-  bool addResourceSubPath(const std::string& resourceName, const std::string& pathName);
-  void registerType(Resources::Type* type);
-  void unregisterType(Resources::Type* type);
+    bool addResourcePath(const std::string& resourceName, const std::string& pathName);
+    bool addResourceSubPath(const std::string& resourceName, const std::string& pathName);
+    void registerType(Resources::Type* type);
+    void unregisterType(Resources::Type* type);
 
-  unsigned int addKeepLevelName(const std::string& keepLevelName);
-  unsigned int getKeepLevelID(const std::string& keepLevelName) const;
-  const std::string& getKeepLevelName(unsigned int keepLevelID) const;
+    unsigned int addKeepLevelName(const std::string& keepLevelName);
+    unsigned int getKeepLevelID(const std::string& keepLevelName) const;
+    const std::string& getKeepLevelName(unsigned int keepLevelID) const;
 
   const std::vector<Resources::Type*> resourceTypes() const { return _resourceTypes; };
-  const Directory& mainGlobalPath() const { return _mainGlobalPath; };
-  /** @returns all global paths without mainGlobalPath */
-  const std::vector<Directory>& globalPaths() const { return _globalPaths; };
+    const Directory& mainGlobalPath() const { return _mainGlobalPath; };
+    /** @returns all global paths without mainGlobalPath */
+    const std::vector<Directory>& globalPaths() const { return _globalPaths; };
 
 
-  bool checkFileInMainPath(const File& fileInside);
+    bool checkFileInMainPath(const File& fileInside);
 
-  bool unloadAllByPriority();
+    bool unloadAllByKeepLevel(const Resources::KeepLevel& keepLevel);
 
-  void debug() const;
+    void debug() const;
 
-  // utility functions for handling files in and around the data-directory
-  static std::string getFullName(const std::string& fileName);
-  static bool isInDataDir(const std::string& fileName);
-private:
-  NewResourceManager();
-  virtual ~NewResourceManager();
+    // utility functions for handling files in and around the data-directory
+    static std::string getFullName(const std::string& fileName);
+    static bool isInDataDir(const std::string& fileName);
+  private:
+    NewResourceManager();
+    virtual ~NewResourceManager();
 
-private:
-  static NewResourceManager*         _singletonRef;       //!< singleton Reference
+  private:
+    static NewResourceManager*         _singletonRef;       //!< singleton Reference
 
-  std::vector<Resources::Type*>      _resourceTypes;
-  //! GLOBALS
-  Directory                          _mainGlobalPath;
-  std::vector<Directory>             _globalPaths;
+    std::vector<Resources::Type*>      _resourceTypes;
+    //! GLOBALS
+    Directory                          _mainGlobalPath;
+    std::vector<Directory>             _globalPaths;
 
-  std::vector<std::string>           _keepLevelNames;
-};
+    std::vector<std::string>           _keepLevelNames;
+  };
+
+}
 
 #endif /* _RESOURCE_MANAGER_H */
Index: branches/new_class_id/src/lib/util/loading/resource.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/resource.cc	(revision 9799)
+++ branches/new_class_id/src/lib/util/loading/resource.cc	(revision 9800)
@@ -21,84 +21,87 @@
 #include "debug.h"
 
-ObjectListDefinition(NewResource);
+
+namespace Resources
+{
+  ObjectListDefinition(NewResource);
 
 
-/**
- * standard constructor
-*/
-NewResource::NewResource (Resources::Type* type)
-    : _pointer(NULL), _type(type)
-{
-  this->registerObject(this, NewResource::_objectList);
-}
+  /**
+   * standard constructor
+  */
+  NewResource::NewResource (Type* type)
+      : _pointer(NULL), _type(type)
+  {
+    this->registerObject(this, NewResource::_objectList);
+  }
 
-/**
- * standard deconstructor
- */
-NewResource::~NewResource ()
-{
-  // delete what has to be deleted here
-}
+  /**
+   * standard deconstructor
+   */
+  NewResource::~NewResource ()
+  {
+    // delete what has to be deleted here
+  }
 
 
-std::string NewResource::locateFile(const std::string& fileName) const
-{
-  if ((NewResourceManager::getInstance()->mainGlobalPath() + File(fileName)).exists() )
+  std::string NewResource::locateFile(const std::string& fileName) const
+  {
+    if ((NewResourceManager::getInstance()->mainGlobalPath() + File(fileName)).exists() )
+      return (NewResourceManager::getInstance()->mainGlobalPath() + File(fileName)).name();
+
+    std::string locatedFile;
+    locatedFile = locateFileInSubDir(NewResourceManager::getInstance()->mainGlobalPath(), fileName);
+    if (!locatedFile.empty())
+    {
+      printf("FILE found %s\n", locatedFile.c_str());
+      return locatedFile;
+    }
+
+    if (File(fileName).exists())
+      return fileName;
+
     return (NewResourceManager::getInstance()->mainGlobalPath() + File(fileName)).name();
-
-  std::string locatedFile;
-  locatedFile = locateFileInSubDir(NewResourceManager::getInstance()->mainGlobalPath(), fileName);
-  if (!locatedFile.empty())
-  {
-    printf("FILE found %s\n", locatedFile.c_str());
-    return locatedFile;
   }
 
-  if (File(fileName).exists())
-    return fileName;
-
-  return (NewResourceManager::getInstance()->mainGlobalPath() + File(fileName)).name();
-}
-
-/**
- * @brief tests in all the SubDirectories defined in Resource under Directory if the fileName exists.
- * @param directory the directory to in what to search for all subdirectories for.
- * @param fileName the Name of the File to query for
- * @return true on success.
- */
-std::string NewResource::locateFileInSubDir(const Directory& directory, const std::string& fileName) const
-{
-  std::vector<Directory>::const_iterator it;
-  for (it = this->_type->resourceSubPaths().begin(); it != this->_type->resourceSubPaths().end(); ++it)
+  /**
+   * @brief tests in all the SubDirectories defined in Resource under Directory if the fileName exists.
+   * @param directory the directory to in what to search for all subdirectories for.
+   * @param fileName the Name of the File to query for
+   * @return true on success.
+   */
+  std::string NewResource::locateFileInSubDir(const Directory& directory, const std::string& fileName) const
   {
-    Directory dir = directory + (*it);
-    File file = dir + File(fileName);
-    printf("Testing %s (from %s in directory %s)\n", file.name().c_str(), fileName.c_str(), dir.name().c_str());
-    if ((dir+ File(fileName)).exists())
-      return (dir+File(fileName)).name();
+    std::vector<Directory>::const_iterator it;
+    for (it = this->_type->resourceSubPaths().begin(); it != this->_type->resourceSubPaths().end(); ++it)
+    {
+      Directory dir = directory + (*it);
+      File file = dir + File(fileName);
+      printf("Testing %s (from %s in directory %s)\n", file.name().c_str(), fileName.c_str(), dir.name().c_str());
+      if ((dir+ File(fileName)).exists())
+        return (dir+File(fileName)).name();
+    }
+    return "";
   }
-  return "";
-}
 
 
 
-Resources::StorePointer* NewResource::acquireResource(const std::string& loadString)
-{
-  //const Resources::Type* const type = Resources::_resourceTypes[this->_type->id()];
+  StorePointer* NewResource::acquireResource(const std::string& loadString)
+  {
+    //const Type* const type = _resourceTypes[this->_type->id()];
 
-  for (unsigned int i = 0; i < _type->storedResources().size(); ++i)
-  {
-    if (_type->storedResources()[i]->loadString() == loadString)
-      return _type->storedResources()[i];
+    for (unsigned int i = 0; i < _type->storedResources().size(); ++i)
+    {
+      if (_type->storedResources()[i]->loadString() == loadString)
+        return _type->storedResources()[i];
+    }
+
+    return NULL;
   }
 
-  return NULL;
-}
 
-
-void NewResource::addResource(Resources::StorePointer* pointer)
-{
-  this->_type->addResource(pointer);
-}
+  void NewResource::addResource(StorePointer* pointer)
+  {
+    this->_type->addResource(pointer);
+  }
 
 
@@ -107,88 +110,89 @@
 
 
-///////////////////
-//// KEEPLEVEL ////
-///////////////////
-Resources::KeepLevel::KeepLevel(const std::string& keepLevelName)
-{
-  this->_keepLevel = NewResourceManager::getInstance()->getKeepLevelID(keepLevelName);
-}
+  ///////////////////
+  //// KEEPLEVEL ////
+  ///////////////////
+  KeepLevel::KeepLevel(const std::string& keepLevelName)
+  {
+    this->_keepLevel = NewResourceManager::getInstance()->getKeepLevelID(keepLevelName);
+  }
 
-const std::string& Resources::KeepLevel::name() const
-{
-  return NewResourceManager::getInstance()->getKeepLevelName(this->_keepLevel);
-}
+  const std::string& KeepLevel::name() const
+  {
+    return NewResourceManager::getInstance()->getKeepLevelName(this->_keepLevel);
+  }
 
 
 
-///////////////////////
-//// STORE POINTER ////
-///////////////////////
-Resources::StorePointer::StorePointer(const std::string& loadString, const Resources::KeepLevel& keeplevel)
-  : _loadString(loadString), _keepLevel(keeplevel)
-{}
+  ///////////////////////
+  //// STORE POINTER ////
+  ///////////////////////
+  StorePointer::StorePointer(const std::string& loadString, const KeepLevel& keeplevel)
+      : _loadString(loadString), _keepLevel(keeplevel)
+  {}
 
 
 
 
-//////////////
-//// TYPE ////
-//////////////
-Resources::Type::Type(const std::string& typeName)
-    : _id(-1), _typeName(typeName)
-{
-  NewResourceManager::getInstance()->registerType(this);
-  PRINTF(4)("Created ResourceType '%s'\n", typeName.c_str());
-}
+  //////////////
+  //// TYPE ////
+  //////////////
+  Type::Type(const std::string& typeName)
+      : _id(-1), _typeName(typeName)
+  {
+    NewResourceManager::getInstance()->registerType(this);
+    PRINTF(4)("Created ResourceType '%s'\n", typeName.c_str());
+  }
 
-Resources::Type::~Type()
-{
-  NewResourceManager::getInstance()->unregisterType(this);
-}
+  Type::~Type()
+  {
+    NewResourceManager::getInstance()->unregisterType(this);
+  }
 
-void Resources::Type::addResource(Resources::StorePointer* resource)
-{
-  this->_storedResources.push_back(resource);
+  void Type::addResource(StorePointer* resource)
+  {
+    this->_storedResources.push_back(resource);
 
-}
+  }
 
-bool Resources::Type::addResourcePath(const std::string& path)
-{
-  std::vector<Directory>::const_iterator it;
-  for (it = this->_resourcePaths.begin(); it != this->_resourcePaths.end(); ++it)
-    if ((*it) == path)
-      return false;
-  this->_resourcePaths.push_back(path);
-  return true;
+  bool Type::addResourcePath(const std::string& path)
+  {
+    std::vector<Directory>::const_iterator it;
+    for (it = this->_resourcePaths.begin(); it != this->_resourcePaths.end(); ++it)
+      if ((*it) == path)
+        return false;
+    this->_resourcePaths.push_back(path);
+    return true;
 
-}
+  }
 
-bool Resources::Type::addResourceSubPath(const std::string& subPath)
-{
-  std::vector<Directory>::const_iterator it;
-  for (it = this->_resourceSubPaths.begin(); it != this->_resourceSubPaths.end(); ++it)
-    if ((*it) == subPath)
-      return false;
-  this->_resourceSubPaths.push_back(subPath);
-  return true;
-}
+  bool Type::addResourceSubPath(const std::string& subPath)
+  {
+    std::vector<Directory>::const_iterator it;
+    for (it = this->_resourceSubPaths.begin(); it != this->_resourceSubPaths.end(); ++it)
+      if ((*it) == subPath)
+        return false;
+    this->_resourceSubPaths.push_back(subPath);
+    return true;
+  }
 
 
-void Resources::Type::setID(int id)
-{
-  this->_id = id;
-}
+  void Type::setID(int id)
+  {
+    this->_id = id;
+  }
 
 
-void Resources::Type::debug() const
-{
-  PRINT(0)(" ResourceType '%s' with ID %d stores %d Resources\n", this->_typeName.c_str(), this->_id, this->_storedResources.size());
-  PRINT(0)("  Paths:\n");
-  for (unsigned int i = 0; i < this->_resourcePaths.size(); ++i)
-    PRINT(0)("    %s\n", this->_resourcePaths[i].name().c_str());
-  PRINT(0)("  Sub-Paths:");
-  for (unsigned int i = 0; i < this->_resourceSubPaths.size(); ++i)
-    PRINT(0)(" '%s'", this->_resourceSubPaths[i].name().c_str());
-  PRINT(0)("\n");
+  void Type::debug() const
+  {
+    PRINT(0)(" ResourceType '%s' with ID %d stores %d Resources\n", this->_typeName.c_str(), this->_id, this->_storedResources.size());
+    PRINT(0)("  Paths:\n");
+    for (unsigned int i = 0; i < this->_resourcePaths.size(); ++i)
+      PRINT(0)("    %s\n", this->_resourcePaths[i].name().c_str());
+    PRINT(0)("  Sub-Paths:");
+    for (unsigned int i = 0; i < this->_resourceSubPaths.size(); ++i)
+      PRINT(0)(" '%s'", this->_resourceSubPaths[i].name().c_str());
+    PRINT(0)("\n");
 
+  }
 }
Index: branches/new_class_id/src/lib/util/loading/resource.h
===================================================================
--- branches/new_class_id/src/lib/util/loading/resource.h	(revision 9799)
+++ branches/new_class_id/src/lib/util/loading/resource.h	(revision 9800)
@@ -30,12 +30,12 @@
   class StorePointer
   {
-    public:
-      StorePointer(const std::string& loadString, const Resources::KeepLevel& keeplevel);
-      const std::string& loadString() const { return _loadString; };
-      const Resources::KeepLevel& keepLevel() const { return _keepLevel; };
+  public:
+    StorePointer(const std::string& loadString, const Resources::KeepLevel& keeplevel);
+    const std::string& loadString() const { return _loadString; };
+    const Resources::KeepLevel& keepLevel() const { return _keepLevel; };
 
-    private:
-      std::string                 _loadString;             //!< An identifier, to match when loading a File.
-      Resources::KeepLevel        _keepLevel;              //!< The Priority of this resource. (can only be increased, so none else will delete this)
+  private:
+    std::string                 _loadString;             //!< An identifier, to match when loading a File.
+    Resources::KeepLevel        _keepLevel;              //!< The Priority of this resource. (can only be increased, so none else will delete this)
   };
 
@@ -73,36 +73,37 @@
     std::vector<Resources::StorePointer*> _storedResources;
   };
+
+
+  //! A NewResource is an Object, that can be loaded from Disk
+  /**
+   *
+   */
+  class NewResource : virtual public BaseObject
+  {
+    ObjectListDeclaration(NewResource);
+
+  public:
+    NewResource(Resources::Type* type);
+    virtual ~NewResource();
+
+    virtual bool reload() { return false; };
+    virtual bool unload() { return false; };
+
+    std::string locateFile(const std::string& fileName) const;
+
+
+  public:
+  protected:
+    Resources::StorePointer* acquireResource(const std::string& loadString);
+    void addResource(Resources::StorePointer* pointer);
+
+  private:
+    std::string locateFileInSubDir(const Directory& directory, const std::string& fileName) const;
+
+  private:
+    Resources::StorePointer*       _pointer;                         //!< Virtual Pointer to the ResourceData.
+    Resources::Type*               _type;                            //!< Type of the NewResource.
+  };
 }
 
-//! A NewResource is an Object, that can be loaded from Disk
-/**
- *
- */
-class NewResource : virtual public BaseObject
-{
-  ObjectListDeclaration(NewResource);
-
-public:
-  NewResource(Resources::Type* type);
-  virtual ~NewResource();
-
-  virtual bool reload() { return false; };
-  virtual bool unload() { return false; };
-
-  std::string locateFile(const std::string& fileName) const;
-
-
-public:
-protected:
-  Resources::StorePointer* acquireResource(const std::string& loadString);
-  void addResource(Resources::StorePointer* pointer);
-
-private:
-  std::string locateFileInSubDir(const Directory& directory, const std::string& fileName) const;
-
-private:
-  Resources::StorePointer*       _pointer;                         //!< Virtual Pointer to the ResourceData.
-  Resources::Type*               _type;                            //!< Type of the NewResource.
-};
-
 #endif /* _RESOURCE_H */