Index: /code/branches/levelKaan/cmake/LibraryConfig.cmake
===================================================================
--- /code/branches/levelKaan/cmake/LibraryConfig.cmake	(revision 9807)
+++ /code/branches/levelKaan/cmake/LibraryConfig.cmake	(revision 9808)
@@ -160,5 +160,6 @@
 # Expand the next statement if newer boost versions are released
 SET(Boost_ADDITIONAL_VERSIONS 1.40 1.40.0 1.41 1.41.0 1.42 1.42.0 1.43 1.43.0
-                              1.44 1.44.0 1.45 1.45.0 1.46 1.46.0 1.46.1)
+                              1.44 1.44.0 1.45 1.45.0 1.46 1.46.0 1.46.1 1.49.0
+			      1.53.0)
 IF(NOT TARDIS)
   FIND_PACKAGE(Boost 1.40 REQUIRED thread filesystem system date_time)
Index: /code/branches/levelKaan/data/gui/layouts/SingleplayerMenu.layout
===================================================================
--- /code/branches/levelKaan/data/gui/layouts/SingleplayerMenu.layout	(revision 9807)
+++ /code/branches/levelKaan/data/gui/layouts/SingleplayerMenu.layout	(revision 9808)
@@ -31,6 +31,7 @@
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="VertScrollbar" Value="True" />
-                <Property Name="HorzScrollbar" Value="True" />
+                <Property Name="HorzScrollbar" Value="False" />
                 <Property Name="UnifiedAreaRect" Value="{{0.1,0},{0.725,0},{0.9,0},{0.875,0}}" />
+		<Property Name="HorzFormatting" Value="WordWrapLeftAligned" />
             </Window>
         </Window>
Index: /code/branches/levelKaan/data/levels/gallery.oxw
===================================================================
--- /code/branches/levelKaan/data/levels/gallery.oxw	(revision 9807)
+++ /code/branches/levelKaan/data/levels/gallery.oxw	(revision 9808)
@@ -74,5 +74,5 @@
       <Model position="0, 20,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="LightningGun.mesh" />
       <Model position="0, 40,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="LightningGun-s.mesh" />
-      <Model position="0, 60,-40" yaw="90" pitch="-90" roll="0" scale="1.5" mesh="LaserBeam.mesh" />
+      <Model position="0, 60,-40" yaw="90" pitch="-90" roll="0" scale="1.5" mesh="LaserBeam2.mesh" />
       <Model position="0, 80,-40" yaw="90" pitch="-90" roll="0" scale="2" mesh="rocket.mesh" />
       <Model position="0,-20,-40" yaw="90" pitch="-90" roll="0" scale="5" mesh="hs-w01.mesh" />
Index: /code/branches/levelKaan/data/levels/includes/weaponSettingsEscort.oxi
===================================================================
--- /code/branches/levelKaan/data/levels/includes/weaponSettingsEscort.oxi	(revision 9807)
+++ /code/branches/levelKaan/data/levels/includes/weaponSettingsEscort.oxi	(revision 9808)
@@ -14,10 +14,10 @@
         </links>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam.mesh" />
-          <!--HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" projectileMesh="LaserBeam.mesh" /-->
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam2.mesh" />
+          <!--HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" projectileMesh="LaserBeam2.mesh" /-->
         </Weapon>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam.mesh" />
-          <!--HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" projectileMesh="LaserBeam.mesh" /-->
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam2.mesh" />
+          <!--HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" projectileMesh="LaserBeam2.mesh" /-->
         </Weapon>
       </WeaponPack>
Index: /code/branches/levelKaan/data/levels/templates/lodInformation.oxt
===================================================================
--- /code/branches/levelKaan/data/levels/templates/lodInformation.oxt	(revision 9807)
+++ /code/branches/levelKaan/data/levels/templates/lodInformation.oxt	(revision 9808)
@@ -16,5 +16,5 @@
       <MeshLodInformation mesh=HydroHarvester.mesh enabled=false />
       <MeshLodInformation mesh=turretHead.mesh enabled=false />
-      <MeshLodInformation mesh=LaserBeam.mesh enabled=false/>
+      <MeshLodInformation mesh=LaserBeam2.mesh enabled=false/>
 
       <!-- disable LOD for some debris meshes which caused a crash (fixed in Ogre 1.7.3) -->
Index: /code/branches/levelKaan/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/levelKaan/src/libraries/core/GUIManager.cc	(revision 9807)
+++ /code/branches/levelKaan/src/libraries/core/GUIManager.cc	(revision 9808)
@@ -350,5 +350,5 @@
             CEGUI::System::getSingleton().setXMLParser("XercesParser");
         }
-        catch (const CEGUI::GenericException& e)
+        catch (const CEGUI::GenericException&)
         {
             // Fall back to default parser
Index: /code/branches/levelKaan/src/libraries/util/CMakeLists.txt
===================================================================
--- /code/branches/levelKaan/src/libraries/util/CMakeLists.txt	(revision 9807)
+++ /code/branches/levelKaan/src/libraries/util/CMakeLists.txt	(revision 9808)
@@ -48,4 +48,5 @@
     ${CEGUI_LIBRARY}
     ${OGRE_LIBRARY}
+    ${Boost_SYSTEM_LIBRARY}
   SOURCE_FILES
     ${UTIL_SRC_FILES}
Index: /code/branches/levelKaan/src/modules/tetris/TetrisBrick.cc
===================================================================
--- /code/branches/levelKaan/src/modules/tetris/TetrisBrick.cc	(revision 9807)
+++ /code/branches/levelKaan/src/modules/tetris/TetrisBrick.cc	(revision 9808)
@@ -54,5 +54,5 @@
     {
         RegisterObject(TetrisBrick);
-        this->shapeIndex_ = static_cast<unsigned int>(rnd(7.0f)); //<! random number between 0 and 7
+        this->shapeIndex_ = 1 + static_cast<unsigned int>(rnd(6.0f)); //<! random number between 0 and 7
         this->stonesPerBrick_ = 4; //<! most tetris bricks is formed by 4 stones
         this->delay_ = false;